local INCLUDE_JUDGE = true

local function try_insert(v, e)
	if not table.contains(v, e) then
		table.insert(v, e)
	end
end

Hooks:PostHook( WeaponFactoryTweakData, "_add_charms_to_all_weapons", "pc__add_charms_to_all_weapons", function(self, tweak_data)
	local force_include

	if not INCLUDE_JUDGE then
		force_include = {}
	else
		force_include = table.list_to_set({
			"judge",
		})

		for id, x_id in pairs(tweak_data.weapon_akimbo_mappings) do
			force_include[x_id] = force_include[id]
		end
	end

	for _, data in pairs(tweak_data.upgrades.definitions) do
		local weapon = tweak_data.weapon[data.weapon_id]
		local factory = self[data.factory_id]

		if force_include[data.weapon_id] or weapon and weapon.categories and table.contains(weapon.categories, "pistol") then
			if factory and factory.uses_parts then
				try_insert(factory.uses_parts, "wpn_fps_upg_bonus_concealment_p3")

				local factory_npc = self[data.factory_id .. "_npc"]
				if factory_npc and factory_npc.uses_parts then
					try_insert(factory_npc.uses_parts, "wpn_fps_upg_bonus_concealment_p3")
				end
			end
		end
	end
end )